#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wave.h"
#include "window_function.h"
#include "sinc.h"
#include "fir_filter.h"

int main(void)
{
  MONO_PCM pcm0, pcm1;
  int n, m, J, L, offset, frame, number_of_frame;
  double fe, delta, *b, *w, *x, *y;
  
  mono_wave_read(&pcm0, "sample04.wav"); /* WAVEt@C烂m̉f[^͂ */
  
  pcm1.fs = pcm0.fs; /* W{g */
  pcm1.bits = pcm0.bits; /* ʎqx */
  pcm1.length = pcm0.length; /* f[^̒ */
  pcm1.s = calloc(pcm1.length, sizeof(double)); /* ̊m */
  
  fe = 1000.0 / pcm0.fs; /* GbWg */
  delta = 1000.0 / pcm0.fs; /* Jڑш敝 */
  
  J = (int)(3.1 / delta + 0.5) - 1; /* x̐ */
  if (J % 2 == 1)
  {
    J++; /* J+1ɂȂ悤ɒ */
  }
  
  b = calloc((J + 1), sizeof(double)); /* ̊m */
  w = calloc((J + 1), sizeof(double)); /* ̊m */
  
  Hanning_window(w, (J + 1)); /* njO */
  
  FIR_LPF(fe, J, b, w); /* FIRtB^̐݌v */
  
  L = 256; /* t[̒ */
  
  number_of_frame = pcm0.length / L; /* t[̐ */
  
  x = calloc((L + J), sizeof(double)); /* ̊m */
  y = calloc(L, sizeof(double)); /* ̊m */
  
  for (frame = 0; frame < number_of_frame; frame++)
  {
    offset = L * frame;
    
    /* Õt[̌㔼JTv */
    for (n = 0; n < L + J; n++)
    {
      if (offset - J + n < 0)
      {
        x[n] = 0.0;
      }
      else
      {
        x[n] = pcm0.s[offset - J + n];
      }
    }
    
    for (n = 0; n < L; n++)
    {
      y[n] = 0.0;
    }
    
    /* tB^O */
    for (n = 0; n < L; n++)
    {
      for (m = 0; m <= J; m++)
      {
        y[n] += b[m] * x[J + n - m];
      }
    }
    
    /* tB^Oʂ̘A */
    for (n = 0; n < L; n++)
    {
      pcm1.s[offset + n] = y[n];
    }
  }
  
  mono_wave_write(&pcm1, "ex6_3.wav"); /* WAVEt@CɃm̉f[^o͂ */
  
  free(pcm0.s); /* ̉ */
  free(pcm1.s); /* ̉ */
  free(b); /* ̉ */
  free(w); /* ̉ */
  free(x); /* ̉ */
  free(y); /* ̉ */
  
  return 0;
}
