#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wave.h"
#include "iir_filter.h"

int main(void)
{
  MONO_PCM pcm0, pcm1;
  int n, m, I, J, L, offset, frame, number_of_frame;
  double fc, Q, a[3], b[3], *x, *y;
  
  mono_wave_read(&pcm0, "sample04.wav"); /* WAVEt@C烂m̉f[^͂ */
  
  pcm1.fs = pcm0.fs; /* W{g */
  pcm1.bits = pcm0.bits; /* ʎqx */
  pcm1.length = pcm0.length; /* f[^̒ */
  pcm1.s = calloc(pcm1.length, sizeof(double)); /* ̊m */
  
  fc = 1000.0 / pcm0.fs; /* Ւfg */
  Q = 1.0 / sqrt(2.0); /* NIeBt@N^ */
  I = 2; /* x̐ */
  J = 2; /* x̐ */
  
  IIR_LPF(fc, Q, a, b); /* IIRtB^̐݌v */
  
  L = 256; /* t[̒ */
  
  number_of_frame = pcm0.length / L; /* t[̐ */
  
  x = calloc((L + J), sizeof(double)); /* ̊m */
  y = calloc((L + I), sizeof(double)); /* ̊m */
  
  for (frame = 0; frame < number_of_frame; frame++)
  {
    offset = L * frame;
    
    /* Õt[̌㔼JTv */
    for (n = 0; n < L + J; n++)
    {
      if (offset - J + n < 0)
      {
        x[n] = 0.0;
      }
      else
      {
        x[n] = pcm0.s[offset - J + n];
      }
    }
    
    /* ÕtB^Oʂ̌㔼ITv */
    for (n = 0; n < L + I; n++)
    {
      if (offset - I + n < 0)
      {
        y[n] = 0.0;
      }
      else
      {
        y[n] = pcm1.s[offset - I + n];
      }
    }
    
    /* tB^O */
    for (n = 0; n < L; n++)
    {
      for (m = 0; m <= J; m++)
      {
        y[I + n] += b[m] * x[J + n - m];
      }
      for (m = 1; m <= I; m++)
      {
        y[I + n] += -a[m] * y[I + n - m];
      }
    }
    
    /* tB^Oʂ̘A */
    for (n = 0; n < L; n++)
    {
      pcm1.s[offset + n] = y[I + n];
    }
  }
  
  mono_wave_write(&pcm1, "ex6_4.wav"); /* WAVEt@CɃm̉f[^o͂ */
  
  free(pcm0.s); /* ̉ */
  free(pcm1.s); /* ̉ */
  
  return 0;
}
